diff --git a/doc/guix.texi b/doc/guix.texi
index e60fef9673..e584b072e1 100644
--- a/doc/guix.texi
+++ b/doc/guix.texi
@@ -41095,6 +41095,10 @@ Version Control Services
 A ``file-like'' object (@pxref{G-Expressions, file-like objects}),
 representing the configuration for Gitolite.
 
+@item @code{git-config} (default: @code{(gitolite-git-configuration)})
+A ``file-like'' object (@pxref{G-Expressions, file-like objects}),
+representing the git configuration for Gitolite.
+
 @item @code{admin-pubkey} (default: @code{#f})
 A ``file-like'' object (@pxref{G-Expressions, file-like objects}) used to
 setup Gitolite.  This will be inserted in to the @file{keydir} directory
@@ -41170,6 +41174,19 @@ Version Control Services
 @end table
 @end deftp
 
+@deftp {Data Type} gitolite-git-configuration
+Data type representing the git configuration file for gitolite.
+
+@table @asis
+@item @code{name} (default: @code{"GNU GNU"})
+User name used for commits (e.g. during setting up the admin
+repository).
+
+@item @code{email} (default: @code{"guix@@localhost"})
+Email used for commits (e.g. during setting up the admin repository).
+
+@end table
+@end deftp
 
 @subsubheading Gitile Service
 
diff --git a/gnu/services/version-control.scm b/gnu/services/version-control.scm
index 67009620b4..68297dee19 100644
--- a/gnu/services/version-control.scm
+++ b/gnu/services/version-control.scm
@@ -66,6 +66,12 @@ (define-module (gnu services version-control)
             gitolite-rc-file-extra-content
             gitolite-rc-file-default-enable
 
+            <gitolite-git-configuration>
+            gitolite-git-configuration
+            gitolite-git-configuration?
+            gitolite-git-configuration-name
+            gitolite-git-configuration-email
+
             gitolite-service-type
 
             gitile-configuration
@@ -320,6 +326,23 @@ (define-gexp-compiler (gitolite-rc-file-compiler
              "# End:\n"
              "# vim: set syn=perl:\n"))))
 
+(define-record-type* <gitolite-git-configuration>
+  gitolite-git-configuration make-gitolite-git-configuration
+  gitolite-git-configuration?
+  (name gitolite-git-configuration-name
+        (default "GNU Guix"))
+  (email gitolite-git-configuration-email
+         (default "guix@localhost")))
+
+(define-gexp-compiler (gitolite-git-configuration-compiler
+                       (config <gitolite-git-configuration>) system target)
+  (match-record config <gitolite-git-configuration>
+                (name email)
+    (apply text-file* "gitconfig"
+           `("[user]\n"
+             "name  = " ,name  "\n"
+             "email = " ,email "\n"))))
+
 (define-record-type* <gitolite-configuration>
   gitolite-configuration make-gitolite-configuration
   gitolite-configuration?
@@ -333,6 +356,8 @@ (define-record-type* <gitolite-configuration>
                   (default "/var/lib/gitolite"))
   (rc-file        gitolite-configuration-rc-file
                   (default (gitolite-rc-file)))
+  (git-config     gitolite-configuration-git-config
+                  (default (gitolite-git-configuration)))
   (admin-pubkey   gitolite-configuration-admin-pubkey))
 
 (define (gitolite-accounts config)
@@ -351,7 +376,8 @@ (define (gitolite-accounts config)
 
 (define (gitolite-activation config)
   (match-record config <gitolite-configuration>
-                (package user group home-directory rc-file admin-pubkey)
+                ( package user group home-directory rc-file admin-pubkey
+                  git-config)
     #~(begin
         (use-modules (ice-9 match)
                      (guix build utils))
@@ -389,12 +415,9 @@ (define (gitolite-activation config)
 
           ;; Set the git configuration, to avoid gitolite trying to use
           ;; the hostname command, as the network might not be up yet
-          (with-output-to-file #$(string-append home-directory "/.gitconfig")
-            (lambda ()
-              (display "[user]
-        name = GNU Guix
-        email = guix@localhost
-")))
+          (copy-file #$git-config
+                     #$(string-append home-directory "/.gitconfig"))
+
           ;; Run Gitolite setup, as this updates the hooks and include the
           ;; admin pubkey if specified. The admin pubkey is required for
           ;; initial setup, and will replace the previous key if run after